=== debian/changelog ===
supertuxkart (0.9-1) unstable; urgency=medium

  * Team upload.

  [ Vincent Cheng ]
  * New upstream release.
    - Drop fix_desktop_file.patch, applied upstream.
    - Rename build_against_system_enet.patch to
      build_against_system_enet_and_glew.patch, and build against system glew.
    - Refresh remaining patches.
  * Add build-depends on libxrandr-dev, libglew-dev.
  * Update my email address.
  * Bump Standards version to 3.9.6, no changes required.

  [ Christoph Egger ]
  * remove myself from uploaders

 -- Vincent Cheng <vcheng@debian.org>  Wed, 13 May 2015 00:32:20 -0700
